"use strict";

var _cssinjs = require("@mxenabled/cssinjs");
var _Theme = require("./Theme");
var _excluded = ["actionText", "buttonRef", "children", "className", "elementProps", "icon", "iconSize", "isActive", "style", "theme"];
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var React = require('react');
var PropTypes = require('prop-types');
var Icon = require('./Icon');
var Spin = require('./Spin');
var _require = require('../constants/App'),
  buttonTypes = _require.buttonTypes,
  themeShape = _require.themeShape;
var StyleUtils = require('../utils/Style');
var Button = /*#__PURE__*/function (_React$Component) {
  _inherits(Button, _React$Component);
  var _super = _createSuper(Button);
  function Button() {
    var _this;
    _classCallCheck(this, Button);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    _defineProperty(_assertThisInitialized(_this), "_windowSizeIsSmall", function (theme) {
      var windowSize = StyleUtils.getWindowSize(theme.BreakPoints);
      return !(windowSize === 'medium' || windowSize === 'large');
    });
    _defineProperty(_assertThisInitialized(_this), "_childIsVisible", function (child) {
      return !child.props || child.props.className !== 'visuallyHidden';
    });
    _defineProperty(_assertThisInitialized(_this), "_hasVisibleChildren", function () {
      if (!_this.props.children) {
        return false;
      }
      if (!Array.isArray(_this.props.children)) {
        return _this._childIsVisible(_this.props.children);
      }
      return _this.props.children.some(_this._childIsVisible);
    });
    _defineProperty(_assertThisInitialized(_this), "styles", function (theme) {
      var windowSizeIsSmall = _this._windowSizeIsSmall(theme);
      return _objectSpread({
        component: _objectSpread({
          borderRadius: 2,
          borderStyle: 'solid',
          borderWidth: 1,
          borderColor: 'transparent',
          boxSizing: 'border-box',
          display: 'inline-block',
          padding: '4px 14px',
          fontSize: theme.FontSizes.MEDIUM,
          fontFamily: theme.Fonts.SEMIBOLD,
          cursor: _this.props.type === 'disabled' ? 'default' : 'pointer',
          transition: 'all .2s ease-in',
          minWidth: 16,
          position: 'relative'
        }, _this.props.style),
        children: {
          justifyContent: 'center',
          display: 'flex',
          alignItems: 'center',
          lineHeight: '20px'
        },
        primary: {
          backgroundColor: theme.Colors.PRIMARY,
          borderColor: theme.Colors.PRIMARY,
          color: theme.Colors.WHITE,
          fill: theme.Colors.WHITE,
          transition: 'all .2s ease-in',
          '&:hover': windowSizeIsSmall ? null : {
            backgroundColor: StyleUtils.adjustColor(theme.Colors.PRIMARY, -15),
            borderColor: StyleUtils.adjustColor(theme.Colors.PRIMARY, -15),
            transition: 'all .2s ease-in'
          },
          '&:active': {
            backgroundColor: StyleUtils.adjustColor(theme.Colors.PRIMARY, -30),
            borderColor: StyleUtils.adjustColor(theme.Colors.PRIMARY, -30),
            transition: 'all .2s ease-in'
          }
        },
        primaryOutline: {
          backgroundColor: 'transparent',
          borderColor: theme.Colors.PRIMARY,
          color: theme.Colors.PRIMARY,
          fill: theme.Colors.PRIMARY,
          transition: 'all .2s ease-in',
          '&:hover': windowSizeIsSmall ? null : {
            backgroundColor: theme.Colors.PRIMARY,
            color: theme.Colors.WHITE,
            fill: theme.Colors.WHITE,
            transition: 'all .2s ease-in'
          },
          '&:active': {
            backgroundColor: StyleUtils.adjustColor(theme.Colors.PRIMARY, -30),
            borderColor: StyleUtils.adjustColor(theme.Colors.PRIMARY, -30),
            color: theme.Colors.WHITE,
            fill: theme.Colors.WHITE,
            transition: 'all .2s ease-in'
          }
        },
        primaryInverse: {
          backgroundColor: theme.Colors.WHITE,
          borderColor: theme.Colors.WHITE,
          color: theme.Colors.PRIMARY,
          fill: theme.Colors.PRIMARY,
          transition: 'all .2s ease-in',
          '&:hover': windowSizeIsSmall ? null : {
            backgroundColor: StyleUtils.adjustColor(theme.Colors.WHITE, -15),
            borderColor: StyleUtils.adjustColor(theme.Colors.WHITE, -15),
            transition: 'all .2s ease-in'
          },
          '&:active': {
            backgroundColor: StyleUtils.adjustColor(theme.Colors.WHITE, -30),
            borderColor: StyleUtils.adjustColor(theme.Colors.WHITE, -30),
            transition: 'all .2s ease-in'
          }
        },
        secondary: {
          backgroundColor: theme.Colors.GRAY_300,
          borderColor: 'transparent',
          color: theme.Colors.GRAY_700,
          fill: theme.Colors.GRAY_500,
          transition: 'all .2s ease-in',
          '&:hover': windowSizeIsSmall ? null : {
            backgroundColor: StyleUtils.adjustColor(theme.Colors.GRAY_300, -15),
            borderColor: 'transparent',
            fill: theme.Colors.WHITE,
            transition: 'all .2s ease-in'
          },
          '&:active': {
            backgroundColor: StyleUtils.adjustColor(theme.Colors.GRAY_300, -30),
            borderColor: 'transparent',
            fill: theme.Colors.WHITE,
            transition: 'all .2s ease-in'
          }
        },
        base: {
          backgroundColor: 'transparent',
          color: theme.Colors.PRIMARY,
          fill: theme.Colors.PRIMARY,
          transition: 'all .2s ease-in',
          borderColor: 'transparent',
          borderRadius: 2,
          borderWidth: 1,
          '&:hover': windowSizeIsSmall ? null : {
            color: StyleUtils.adjustColor(theme.Colors.PRIMARY, -8),
            fill: StyleUtils.adjustColor(theme.Colors.PRIMARY, -8),
            transition: 'all .2s ease-in',
            borderColor: theme.Colors.GRAY_300
          },
          '&:active': {
            color: StyleUtils.adjustColor(theme.Colors.PRIMARY, -16),
            fill: StyleUtils.adjustColor(theme.Colors.PRIMARY, -16),
            transition: 'all .2s ease-in',
            backgroundColor: theme.Colors.GRAY_100
          }
        },
        neutral: {
          backgroundColor: 'transparent',
          borderColor: theme.Colors.GRAY_300,
          borderRadius: 2,
          borderWidth: 1,
          color: theme.Colors.PRIMARY,
          fill: theme.Colors.PRIMARY,
          '&:hover': windowSizeIsSmall ? null : {
            backgroundColor: theme.Colors.GRAY_100
          },
          '&:active': {
            backgroundColor: StyleUtils.adjustColor(theme.Colors.GRAY_100, -15)
          }
        },
        disabled: {
          backgroundColor: 'transparent',
          borderColor: theme.Colors.GRAY_300,
          color: theme.Colors.GRAY_300,
          fill: theme.Colors.GRAY_300
        },
        icon: {
          marginLeft: _this._hasVisibleChildren() ? -4 : 0,
          marginRight: _this._hasVisibleChildren() ? 5 : 0
        },
        buttonText: {
          marginLeft: _this.props.isActive && _this.props.actionText ? 10 : 0
        }
      }, _this.props.styles);
    });
    return _this;
  }
  _createClass(Button, [{
    key: "render",
    value: function render() {
      // Manually consume everything that isn't going to be passed down to the button so we don't have to keep adding props one at a time.
      // Keep elementProps for backwards compatibility.
      var _this$props = this.props,
        actionText = _this$props.actionText,
        buttonRef = _this$props.buttonRef,
        children = _this$props.children,
        className = _this$props.className,
        elementProps = _this$props.elementProps,
        icon = _this$props.icon,
        iconSize = _this$props.iconSize,
        isActive = _this$props.isActive,
        style = _this$props.style,
        theme = _this$props.theme,
        rest = _objectWithoutProperties(_this$props, _excluded);
      var mergedTheme = StyleUtils.mergeTheme(theme);
      var styles = this.styles(mergedTheme);

      // We need to remove the styles prop from rest so we don't pass it to children.
      delete rest.styles;
      return /*#__PURE__*/React.createElement("button", _extends({
        className: 'mx-button ' + (0, _cssinjs.css)(_objectSpread(_objectSpread(_objectSpread({}, styles.component), styles[this.props.type]), style)) + ' ' + (className || ''),
        disabled: this.props.type === 'disabled',
        ref: buttonRef
      }, rest, elementProps), /*#__PURE__*/React.createElement("div", {
        style: styles.children
      }, icon && !isActive && /*#__PURE__*/React.createElement(Icon, {
        size: iconSize,
        style: styles.icon,
        type: icon
      }), isActive && /*#__PURE__*/React.createElement(Spin, {
        direction: "counterclockwise"
      }, /*#__PURE__*/React.createElement(Icon, {
        size: iconSize,
        type: "spinner"
      })), /*#__PURE__*/React.createElement("div", {
        style: styles.buttonText
      }, isActive ? actionText : children)));
    }
  }]);
  return Button;
}(React.Component);
_defineProperty(Button, "propTypes", {
  actionText: PropTypes.string,
  'aria-label': PropTypes.string,
  buttonRef: PropTypes.func,
  className: PropTypes.string,
  elementProps: PropTypes.object,
  icon: PropTypes.string,
  iconSize: PropTypes.number,
  isActive: PropTypes.bool,
  onClick: PropTypes.func,
  style: PropTypes.object,
  styles: PropTypes.object,
  theme: themeShape,
  type: PropTypes.oneOf(buttonTypes)
});
_defineProperty(Button, "defaultProps", {
  elementProps: {},
  onClick: function onClick() {},
  iconSize: 20,
  isActive: false,
  styles: {},
  type: 'primary'
});
module.exports = (0, _Theme.withTheme)(Button);