"use strict";

var _Theme = require("./Theme");
require("moment/locale/es");
require("moment/locale/fr");
var _KeyPress = require("../utils/KeyPress");
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var React = require('react');
var PropTypes = require('prop-types');
var keycode = require('keycode');
var moment = require('moment');
var _merge = require('lodash/merge');
var Icon = require('./Icon');
var Button = require('./Button');
var MXFocusTrap = require('../components/MXFocusTrap');
var _require = require('../constants/DateRangePicker'),
  SelectedBox = _require.SelectedBox;
var _require2 = require('../constants/App'),
  themeShape = _require2.themeShape;
var StyleUtils = require('../utils/Style');
var MonthTable = require('./DateRangePicker/MonthTable');
var _require3 = require('./DateRangePicker/Selector'),
  MonthSelector = _require3.MonthSelector,
  YearSelector = _require3.YearSelector;
var SelectionPane = require('./DateRangePicker/SelectionPane');
var DateRangePicker = /*#__PURE__*/function (_React$Component) {
  _inherits(DateRangePicker, _React$Component);
  var _super = _createSuper(DateRangePicker);
  function DateRangePicker(props) {
    var _this;
    _classCallCheck(this, DateRangePicker);
    _this = _super.call(this, props);
    _defineProperty(_assertThisInitialized(_this), "_getDateFormat", function (isLargeOrMediumWindowSize) {
      return isLargeOrMediumWindowSize ? _this.props.format : 'MMM D';
    });
    _defineProperty(_assertThisInitialized(_this), "_isLargeOrMediumWindowSize", function (theme) {
      var windowSize = StyleUtils.getWindowSize(theme.BreakPoints);
      return windowSize === 'large' || windowSize === 'medium';
    });
    _defineProperty(_assertThisInitialized(_this), "_endDateIsBeforeStartDate", function (startDate, endDate) {
      return moment.unix(endDate).isBefore(moment.unix(startDate));
    });
    _defineProperty(_assertThisInitialized(_this), "_focusFromButton", function () {
      if (_this._fromButton && _this._fromButton.focus) {
        _this._fromButton.focus();
      }
    });
    _defineProperty(_assertThisInitialized(_this), "_focusToButton", function () {
      if (_this._toButton && _this._toButton.focus) {
        _this._toButton.focus();
      }
    });
    _defineProperty(_assertThisInitialized(_this), "_getToggledSelectBox", function (currentSelectBox) {
      return currentSelectBox === SelectedBox.FROM ? SelectedBox.TO : SelectedBox.FROM;
    });
    _defineProperty(_assertThisInitialized(_this), "_handleDateSelect", function (date) {
      var theme = StyleUtils.mergeTheme(_this.props.theme);
      var isLargeOrMediumWindowSize = _this._isLargeOrMediumWindowSize(theme);
      var _this$state = _this.state,
        selectedBox = _this$state.selectedBox,
        selectedEndDate = _this$state.selectedEndDate,
        selectedStartDate = _this$state.selectedStartDate;
      var endDate = selectedBox === SelectedBox.TO ? date : selectedEndDate;
      var startDate = selectedBox === SelectedBox.FROM ? date : selectedStartDate;
      var modifiedRangeCompleteButDatesInversed = startDate && endDate && _this._endDateIsBeforeStartDate(startDate, endDate);
      _this.setState(function (state) {
        return {
          currentDate: date,
          focusedDay: date,
          selectedDefaultRange: '',
          selectedBox: isLargeOrMediumWindowSize ? _this._getToggledSelectBox(state.selectedBox) : state.selectedBox,
          selectedStartDate: modifiedRangeCompleteButDatesInversed ? endDate : startDate,
          selectedEndDate: modifiedRangeCompleteButDatesInversed ? moment.unix(startDate).endOf('day').unix() : moment.unix(endDate).endOf('day').unix(),
          showCalendar: false
        };
      }, function () {
        if (!isLargeOrMediumWindowSize) {
          switch (_this.state.selectedBox) {
            case SelectedBox.FROM:
              _this._focusFromButton();
              break;
            case SelectedBox.TO:
              _this._focusToButton();
              break;
          }
        }
      });
    });
    _defineProperty(_assertThisInitialized(_this), "_handleDefaultRangeSelection", function (range) {
      _this.setState({
        selectedDefaultRange: range.displayValue,
        selectedStartDate: range.getStartDate(),
        selectedEndDate: range.getEndDate(),
        focusedDay: range.getEndDate()
      });
    });
    _defineProperty(_assertThisInitialized(_this), "_handleDayKeyDown", function (date, e) {
      var startDate = moment.unix(_this.state.currentDate).startOf('month').startOf('week');
      var endDate = moment.unix(_this.state.currentDate).endOf('month').endOf('week');
      if (keycode(e) === 'right') {
        var day = moment.unix(_this.state.focusedDay).add(1, 'days').startOf('day');
        if (day.isSameOrAfter(endDate)) {
          _this.setState({
            currentDate: day.unix()
          });
        }
        _this.setState({
          focusedDay: day.unix()
        });
      } else if (keycode(e) === 'left') {
        var _day = moment.unix(_this.state.focusedDay).subtract(1, 'days').startOf('day');
        if (_day.isBefore(startDate)) {
          _this.setState({
            currentDate: _day.unix()
          });
        }
        _this.setState({
          focusedDay: _day.unix()
        });
      } else if ((0, _KeyPress.isEnterOrSpaceKey)(e)) {
        e.preventDefault();
        e.stopPropagation();
        _this._handleDateSelect(date);
      } else if (keycode(e) === 'up') {
        e.preventDefault(); //stop browser scrolling
        var _day2 = moment.unix(_this.state.focusedDay).subtract(7, 'days').startOf('day');
        if (_day2.isBefore(startDate)) {
          _this.setState({
            currentDate: _day2.unix()
          });
        }
        _this.setState({
          focusedDay: _day2.unix()
        });
      } else if (keycode(e) === 'down') {
        e.preventDefault(); //stop browser scrolling
        var _day3 = moment.unix(_this.state.focusedDay).add(7, 'days').startOf('day');
        if (_day3.isSameOrAfter(endDate)) {
          _this.setState({
            currentDate: _day3.unix()
          });
        }
        _this.setState({
          focusedDay: _day3.unix()
        });
      }
    });
    _defineProperty(_assertThisInitialized(_this), "_handleDateHover", function (activeSelectDate) {
      _this.setState({
        activeSelectDate: activeSelectDate
      });
    });
    _defineProperty(_assertThisInitialized(_this), "_toggleSelectionPane", function () {
      if (!_this.state.showSelectionPane) {
        _this.props.onOpen();
      }
      _this.setState({
        showSelectionPane: !_this.state.showSelectionPane
      });
    });
    _defineProperty(_assertThisInitialized(_this), "_isInActiveRange", function (selectedStart, selectedEnd, active, date) {
      var start = selectedStart || active;
      var end = selectedEnd || active;
      var isActive;
      if (start < end) {
        isActive = date.isSameOrAfter(moment.unix(start)) && date.isSameOrBefore(moment.unix(end));
      } else {
        isActive = date.isSameOrBefore(moment.unix(start)) && date.isSameOrAfter(moment.unix(end));
      }
      return isActive;
    });
    _defineProperty(_assertThisInitialized(_this), "_formatMomentDate", function (date) {
      var format = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'MMMM Do, YYYY';
      return moment.unix(date).format(format);
    });
    _defineProperty(_assertThisInitialized(_this), "_getDateRangePosition", function (selectedStart, selectedEnd, active, date) {
      var start = selectedStart || active;
      var end = selectedEnd || active;
      var where;
      if (start < end) {
        if (date.isSame(moment.unix(start))) {
          where = 'Start';
        } else if (date.isSame(moment.unix(end))) {
          where = 'End';
        }
      } else if (start > end) {
        if (date.isSame(moment.unix(start))) {
          where = 'End';
        } else if (date.isSame(moment.unix(end))) {
          where = 'Start';
        }
      }
      return where;
    });
    _defineProperty(_assertThisInitialized(_this), "_resetToPropValuesAndClose", function () {
      _this.props.onClose();
      _this.setState({
        currentDate: _this.props.selectedEndDate || moment().startOf('day').unix(),
        focusedDay: _this.props.selectedEndDate || moment().startOf('day').unix(),
        selectedStartDate: _this.props.selectedStartDate,
        selectedEndDate: _this.props.selectedEndDate,
        showCalendar: false,
        showSelectionPane: false
      });
    });
    _defineProperty(_assertThisInitialized(_this), "styles", function (theme, isLargeOrMediumWindowSize) {
      return _merge({}, {
        component: _objectSpread({
          backgroundColor: theme.Colors.WHITE,
          borderColor: _this.state.showSelectionPane ? theme.Colors.PRIMARY : theme.Colors.GRAY_300,
          borderRadius: 3,
          borderStyle: 'solid',
          borderWidth: 1,
          boxSizing: 'border-box',
          color: theme.Colors.GRAY_900,
          cursor: 'pointer',
          display: 'inline-block',
          fontFamily: theme.FontFamily,
          fontSize: theme.FontSizes.MEDIUM,
          padding: '10px 15px',
          position: _this.props.isRelative && window.innerWidth > 450 ? 'relative' : 'static',
          width: '100%'
        }, _this.props.style),
        container: {
          flexDirection: isLargeOrMediumWindowSize ? 'row' : 'column-reverse'
        },
        bottomPane: {
          backgroundColor: theme.Colors.GRAY_100,
          display: 'flex',
          flexDirection: 'row',
          padding: theme.Spacing.SMALL,
          paddingRight: theme.Spacing.MEDIUM,
          justifyContent: 'flex-end'
        },
        bottomPaneMobile: {
          display: 'flex',
          flexDirection: 'row',
          padding: theme.Spacing.SMALL,
          paddingTop: theme.Spacing.MEDIUM,
          justifyContent: 'flex-end'
        },
        selectionContainer: {
          display: 'flex',
          flexDirection: 'column',
          flex: '1 0 auto'
        },
        row: {
          display: 'flex',
          flexDirection: 'row',
          justifyContent: 'center'
        },
        // Selected Date styles
        selectedDateButton: {
          alignItems: 'center',
          backgroundColor: 'transparent',
          border: 'none',
          display: 'flex',
          justifyContent: 'space-between',
          margin: 0,
          padding: 0,
          width: '100%'
        },
        selectedDateIcon: {
          fill: theme.Colors.PRIMARY,
          marginRight: 5
        },
        selectedDateText: {
          color: _this.state.selectedStartDate && _this.state.selectedEndDate ? theme.Colors.GRAY_700 : theme.Colors.GRAY_500
        },
        selectedDateCaret: {
          fill: _this.state.showSelectionPane ? theme.Colors.PRIMARY : theme.Colors.GRAY_500
        },
        //Calendar Styles
        optionsWrapper: {
          backgroundColor: theme.Colors.WHITE,
          border: '1px solid ' + theme.Colors.GRAY_300,
          borderRadius: 3,
          boxShadow: theme.ShadowHigh,
          boxSizing: 'border-box',
          display: _this.state.showSelectionPane ? 'flex' : 'none',
          flexDirection: isLargeOrMediumWindowSize ? 'row' : 'column',
          justifyContent: 'center',
          marginTop: isLargeOrMediumWindowSize ? 10 : 5,
          position: 'absolute',
          left: isLargeOrMediumWindowSize ? '50%' : 0,
          right: isLargeOrMediumWindowSize ? 'auto' : 0,
          transform: isLargeOrMediumWindowSize ? 'translateX(-50%)' : null,
          zIndex: 10,
          maxWidth: 575,
          width: window.innerWidth
        },
        calendarWrapper: {
          boxSizing: 'border-box',
          padding: 20,
          margin: 'auto',
          maxWidth: 275,
          width: isLargeOrMediumWindowSize ? 275 : '100%'
        },
        //Calendar Header
        calendarHeader: {
          alignItems: 'center',
          color: theme.Colors.GRAY_700,
          display: 'flex',
          fontSize: theme.FontSizes.LARGE,
          height: 30,
          justifyContent: 'space-between',
          marginBottom: 15,
          position: 'relative',
          textAlign: 'center'
        },
        //Calendar week
        calendarWeek: {
          alignItems: 'center',
          color: theme.Colors.GRAY_500,
          display: 'flex',
          fontFamily: theme.Fonts.SEMIBOLD,
          fontSize: theme.FontSizes.SMALL,
          height: 30,
          justifyContent: 'center',
          marginBottom: 2
        },
        calendarWeekDay: {
          textAlign: 'center',
          width: 30
        },
        //Calendar table
        calendarTable: {
          alignItems: 'center',
          display: 'flex',
          flexWrap: 'wrap',
          justifyContent: 'center'
        },
        calendarDay: {
          alignItems: 'center',
          boxSizing: 'border-box',
          color: theme.Colors.GRAY_700,
          cursor: 'pointer',
          display: 'flex',
          height: 30,
          justifyContent: 'center',
          marginBottom: 2,
          width: 30,
          '&:hover': {
            border: '1px solid' + theme.Colors.PRIMARY
          }
        },
        calendarDayDisabled: {
          color: theme.Colors.GRAY_300,
          '&:hover': {
            cursor: 'default',
            border: 'none'
          }
        },
        today: {
          backgroundColor: theme.Colors.GRAY_300,
          color: theme.Colors.GRAY_700
        },
        currentMonth: {
          color: theme.Colors.GRAY_700
        },
        applyButton: {
          display: 'flex',
          justifyContent: 'flex-end',
          marginLeft: theme.Spacing.MEDIUM
        },
        //Selected and Selecting Range
        selectedDay: {
          backgroundColor: theme.Colors.PRIMARY,
          color: theme.Colors.WHITE
        },
        betweenDay: {
          backgroundColor: StyleUtils.adjustHexOpacity(theme.Colors.PRIMARY, 0.5),
          borderRadius: 0,
          '&:hover': {
            border: '1px solid' + theme.Colors.PRIMARY
          }
        },
        //Scrim
        scrim: {
          bottom: 0,
          left: 0,
          position: 'fixed',
          right: 0,
          top: 0,
          zIndex: 9
        }
      }, _this.props.styles);
    });
    _this.state = {
      currentDate: props.selectedEndDate || moment().startOf('day').unix(),
      focusedDay: props.selectedEndDate || moment().startOf('day').unix(),
      selectedBox: SelectedBox.FROM,
      selectedDefaultRange: '',
      selectedStartDate: _this.props.selectedStartDate,
      selectedEndDate: _this.props.selectedEndDate,
      showSelectionPane: false
    };
    return _this;
  }
  _createClass(DateRangePicker, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      moment.locale(this.props.locale);
    }
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(newProps) {
      var isUpdatedSelectedEndDate = newProps.selectedEndDate && newProps.selectedEndDate !== this.props.selectedEndDate;
      var isUpdatedSelectedStartDate = newProps.selectedStartDate && newProps.selectedStartDate !== this.props.selectedStartDate;
      if (isUpdatedSelectedEndDate || isUpdatedSelectedStartDate) {
        this.setState({
          focusedDay: isUpdatedSelectedEndDate ? newProps.selectedEndDate : this.state.focusedDay,
          currentDate: newProps.selectedEndDate ? newProps.selectedEndDate : newProps.selectedStartDate,
          selectedEndDate: isUpdatedSelectedEndDate ? newProps.selectedEndDate : this.state.selectedEndDate,
          selectedStartDate: isUpdatedSelectedStartDate ? newProps.selectedStartDate : this.state.selectedStartDate
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props = this.props,
        children = _this$props.children,
        getTranslation = _this$props.getTranslation,
        placeholderText = _this$props.placeholderText;
      var theme = StyleUtils.mergeTheme(this.props.theme);
      var isLargeOrMediumWindowSize = this._isLargeOrMediumWindowSize(theme);
      var styles = this.styles(theme, isLargeOrMediumWindowSize);
      var shouldShowCalendarIcon = StyleUtils.getWindowSize(theme.BreakPoints) !== 'small';
      var showCalendar = isLargeOrMediumWindowSize || this.state.showCalendar;
      var _this$state2 = this.state,
        selectedDefaultRange = _this$state2.selectedDefaultRange,
        selectedEndDate = _this$state2.selectedEndDate,
        selectedStartDate = _this$state2.selectedStartDate;
      var defaultRangesWithCopy = [{
        displayValue: getTranslation('This Month'),
        getEndDate: function getEndDate() {
          return moment().endOf('month').unix();
        },
        getStartDate: function getStartDate() {
          return moment().startOf('month').unix();
        }
      }, {
        displayValue: getTranslation('Last 30 Days'),
        getEndDate: function getEndDate() {
          return moment().endOf('day').unix();
        },
        getStartDate: function getStartDate() {
          return moment().subtract(29, 'days').startOf('day').unix();
        }
      }, {
        displayValue: getTranslation('Last Month'),
        getEndDate: function getEndDate() {
          return moment().subtract(1, 'months').endOf('month').unix();
        },
        getStartDate: function getStartDate() {
          return moment().subtract(1, 'months').startOf('month').unix();
        }
      }, {
        displayValue: getTranslation('Last 90 Days'),
        getEndDate: function getEndDate() {
          return moment().endOf('day').unix();
        },
        getStartDate: function getStartDate() {
          return moment().subtract(89, 'days').startOf('day').unix();
        }
      }, {
        displayValue: getTranslation('Year To Date'),
        getEndDate: function getEndDate() {
          return moment().endOf('day').unix();
        },
        getStartDate: function getStartDate() {
          return moment().startOf('year').unix();
        }
      }, {
        displayValue: getTranslation('Last Year'),
        getEndDate: function getEndDate() {
          return moment().endOf('year').subtract(1, 'y').unix();
        },
        getStartDate: function getStartDate() {
          return moment().startOf('year').subtract(1, 'y').unix();
        }
      }];
      var weekDayNames = moment.weekdays();
      var weekDayObject = moment.weekdaysMin().map(function (d, index) {
        return {
          label: d,
          value: weekDayNames[index]
        };
      });
      var mergedFocusTrapProps = _objectSpread({
        focusTrapOptions: {
          clickOutsideDeactivates: true
        },
        paused: false
      }, this.props.focusTrapProps);
      var buttonProps = {
        'aria-controls': this.state.showSelectionPane ? 'calendarMenu' : null,
        'aria-haspopup': true,
        'aria-label': "".concat(placeholderText).concat(this.props.selectedStartDate && this.props.selectedEndDate ? getTranslation("%1 to %2 currently selected", this._formatMomentDate(this.props.selectedStartDate), this._formatMomentDate(this.props.selectedEndDate)) : ''),
        onClick: this._toggleSelectionPane
      };
      return /*#__PURE__*/React.createElement("div", {
        className: "mx-date-range-picker",
        style: styles.component
      }, children && typeof children === 'function' ? this.props.children(buttonProps) : /*#__PURE__*/React.createElement("button", _extends({}, buttonProps, {
        ref: this.props.elementRef,
        style: styles.selectedDateButton
      }), shouldShowCalendarIcon ? /*#__PURE__*/React.createElement(Icon, {
        size: 20,
        style: styles.selectedDateIcon,
        type: "calendar"
      }) : null, /*#__PURE__*/React.createElement("div", {
        className: "mx-date-range-picker-selected-date-text",
        style: styles.selectedDateText
      }, this.props.selectedStartDate && this.props.selectedEndDate ? /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("span", null, this._formatMomentDate(this.props.selectedStartDate, this._getDateFormat(isLargeOrMediumWindowSize))), /*#__PURE__*/React.createElement("span", null, " - "), /*#__PURE__*/React.createElement("span", null, this._formatMomentDate(this.props.selectedEndDate, this._getDateFormat(isLargeOrMediumWindowSize)))) : placeholderText), /*#__PURE__*/React.createElement(Icon, {
        size: 20,
        style: styles.selectedDateCaret,
        type: this.state.showSelectionPane ? 'caret-up' : 'caret-down'
      })), /*#__PURE__*/React.createElement("div", {
        style: styles.container
      }, /*#__PURE__*/React.createElement("div", null, this.state.showSelectionPane ? /*#__PURE__*/React.createElement(MXFocusTrap, mergedFocusTrapProps, /*#__PURE__*/React.createElement("div", {
        id: "calendarMenu",
        onKeyUp: function onKeyUp(e) {
          if (keycode(e) === 'esc') {
            _this2.setState({
              showSelectionPane: false
            }, function () {
              _this2.props.onCancel();
              _this2.props.onClose();
            });
          }
        },
        style: styles.optionsWrapper
      }, /*#__PURE__*/React.createElement("div", {
        className: "mx-date-range-picker-pane",
        style: styles.selectionContainer
      }, /*#__PURE__*/React.createElement("div", {
        style: styles.row
      }, !this.state.showCalendar && /*#__PURE__*/React.createElement("div", null, this.props.showDefaultRanges && /*#__PURE__*/React.createElement(SelectionPane, {
        defaultRanges: this.props.defaultRanges || defaultRangesWithCopy,
        getFromButtonRef: function getFromButtonRef(ref) {
          return _this2._fromButton = ref;
        },
        getToButtonRef: function getToButtonRef(ref) {
          return _this2._toButton = ref;
        },
        getTranslation: this.props.getTranslation,
        handleDefaultRangeSelection: this._handleDefaultRangeSelection,
        onDateBoxClick: function onDateBoxClick(date, selectedBox) {
          _this2.setState({
            currentDate: date || moment().unix(),
            selectedBox: selectedBox,
            showCalendar: !isLargeOrMediumWindowSize
          });
        },
        selectedBox: this.state.selectedBox,
        selectedEndDate: selectedEndDate,
        selectedStartDate: selectedStartDate,
        styles: styles,
        theme: theme
      })), showCalendar ? /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("div", {
        className: "mx-date-range-picker-calendar",
        style: styles.calendarWrapper
      }, /*#__PURE__*/React.createElement("div", {
        className: "mx-date-range-picker-calendar-header",
        style: styles.calendarHeader
      }, /*#__PURE__*/React.createElement(MonthSelector, {
        currentDate: this.state.currentDate,
        getTranslation: this.props.getTranslation,
        setCurrentDate: function setCurrentDate(currentDate) {
          return _this2.setState({
            currentDate: currentDate,
            focusedDay: currentDate
          });
        }
      }), /*#__PURE__*/React.createElement(YearSelector, {
        currentDate: this.state.currentDate,
        getTranslation: this.props.getTranslation,
        setCurrentDate: function setCurrentDate(currentDate) {
          return _this2.setState({
            currentDate: currentDate,
            focusedDay: currentDate
          });
        }
      })), /*#__PURE__*/React.createElement("div", {
        className: "mx-date-range-picker-week-label",
        style: styles.calendarWeek
      }, weekDayObject.map(function (day, index) {
        return /*#__PURE__*/React.createElement("div", {
          "aria-hidden": true,
          key: "".concat(day.value, "-").concat(index),
          style: styles.calendarWeekDay
        }, day.label);
      })), /*#__PURE__*/React.createElement(MonthTable, {
        activeSelectDate: this.state.activeSelectDate,
        currentDate: this.state.currentDate,
        focusedDay: this.state.focusedDay || this.state.currentDate,
        getDateRangePosition: this._getDateRangePosition,
        getTranslation: this.props.getTranslation,
        handleDateHover: this._handleDateHover,
        handleDateSelect: this._handleDateSelect,
        handleKeyDown: this._handleDayKeyDown,
        isInActiveRange: this._isInActiveRange,
        minimumDate: this.props.minimumDate,
        selectedBox: this.state.selectedBox,
        selectedEndDate: selectedEndDate,
        selectedStartDate: selectedStartDate,
        styles: styles
      }))) : null), /*#__PURE__*/React.createElement("div", {
        style: styles.bottomPane
      }, /*#__PURE__*/React.createElement(Button, {
        "aria-label": getTranslation('Cancel Date Range Selection'),
        onClick: function onClick() {
          _this2.props.onCancel();
          _this2._resetToPropValuesAndClose();
        },
        theme: this.props.theme,
        type: "secondary"
      }, getTranslation('Cancel')), /*#__PURE__*/React.createElement(Button, {
        "aria-label": getTranslation('Apply Date Range Selection'),
        onClick: function onClick() {
          _this2.props.onDateRangeSelect(selectedStartDate, selectedEndDate, selectedDefaultRange);
          _this2._resetToPropValuesAndClose();
        },
        style: styles.applyButton,
        theme: this.props.theme,
        type: selectedStartDate && selectedEndDate ? 'primary' : 'disabled'
      }, getTranslation('Apply')))))) : null)), this.state.showSelectionPane ? /*#__PURE__*/React.createElement("div", {
        onClick: function onClick() {
          _this2.props.onCancel();
          _this2._resetToPropValuesAndClose();
        },
        style: styles.scrim
      }) : null);
    }
  }]);
  return DateRangePicker;
}(React.Component);
_defineProperty(DateRangePicker, "propTypes", {
  defaultRanges: PropTypes.arrayOf(PropTypes.shape({
    displayValue: PropTypes.string,
    getEndDate: PropTypes.func,
    getStartDate: PropTypes.func
  })),
  elementRef: PropTypes.func,
  focusTrapProps: PropTypes.object,
  format: PropTypes.string,
  getTranslation: PropTypes.func.isRequired,
  isRelative: PropTypes.bool,
  locale: PropTypes.string,
  minimumDate: PropTypes.number,
  onCancel: PropTypes.func,
  onClose: PropTypes.func,
  onDateRangeSelect: PropTypes.func,
  onOpen: PropTypes.func,
  placeholderText: PropTypes.string,
  selectedEndDate: PropTypes.number,
  selectedStartDate: PropTypes.number,
  showDefaultRanges: PropTypes.bool,
  style: PropTypes.object,
  styles: PropTypes.object,
  theme: themeShape
});
_defineProperty(DateRangePicker, "defaultProps", {
  focusTrapProps: {},
  format: 'MMM D, YYYY',
  isRelative: true,
  locale: 'en',
  onCancel: function onCancel() {},
  onClose: function onClose() {},
  onOpen: function onOpen() {},
  showDefaultRanges: false
});
module.exports = (0, _Theme.withTheme)(DateRangePicker);