"use strict";

var _Theme = require("../Theme");
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var React = require('react');
var moment = require('moment');
var PropTypes = require('prop-types');
var DefaultRanges = require('../DateRangePicker/DefaultRanges');
var _require = require('../../constants/DateRangePicker'),
  SelectedBox = _require.SelectedBox;
var _require2 = require('../../constants/App'),
  themeShape = _require2.themeShape;
var StyleUtils = require('../../utils/Style');
var SelectionPane = /*#__PURE__*/function (_React$Component) {
  _inherits(SelectionPane, _React$Component);
  var _super = _createSuper(SelectionPane);
  function SelectionPane() {
    var _this;
    _classCallCheck(this, SelectionPane);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    _defineProperty(_assertThisInitialized(_this), "_handleDateBoxClick", function (date, selectedBox) {
      _this.props.onDateBoxClick(date, selectedBox);
    });
    _defineProperty(_assertThisInitialized(_this), "_formatDate", function (date) {
      return moment.unix(date).format('MMM D, YYYY');
    });
    _defineProperty(_assertThisInitialized(_this), "styles", function (theme) {
      var isLargeOrMediumWindowSize = ['large', 'medium'].indexOf(StyleUtils.getWindowSize(theme.BreakPoints)) !== -1;
      return {
        container: {
          display: 'flex',
          flexDirection: 'column',
          height: '100%',
          borderRight: isLargeOrMediumWindowSize ? '1px solid ' + theme.Colors.GRAY_300 : 'none',
          padding: theme.Spacing.MEDIUM,
          boxSizing: 'border-box',
          width: 275
        },
        calendarHeaderNav: {
          width: 35,
          cursor: 'pointer'
        },
        boxLabel: {
          fontFamily: theme.FontFamily,
          fontSize: theme.FontSizes.MEDIUM,
          color: theme.Colors.GRAY_700,
          display: 'inline-block',
          marginTop: theme.Spacing.SMALL
        },
        dateSelectBox: {
          backgroundColor: 'transparent',
          borderColor: theme.Colors.GRAY_300,
          borderRadius: 3,
          borderStyle: 'solid',
          borderWidth: 1,
          boxSizing: 'border-box',
          color: theme.Colors.GRAY_700,
          cursor: 'pointer',
          display: 'block',
          fontFamily: theme.FontFamily,
          fontSize: theme.FontSizes.MEDIUM,
          marginBottom: theme.Spacing.SMALL,
          marginTop: theme.Spacing.XSMALL,
          padding: '10px 15px',
          textAlign: 'left',
          width: '100%'
        },
        selectedDateSelectBox: {
          borderColor: theme.Colors.PRIMARY,
          cursor: 'pointer',
          color: theme.Colors.PRIMARY
        },
        //Default Ranges
        defaultRangesTitle: {
          color: theme.Colors.PRIMARY,
          fontFamily: theme.Fonts.SEMIBOLD,
          fontSize: theme.FontSizes.SMALL,
          padding: "".concat(theme.Spacing.LARGE, "px 0px ").concat(theme.Spacing.SMALL, "px 0px")
        },
        rangeOptions: {
          boxSizing: 'border-box',
          color: theme.Colors.GRAY_700,
          display: 'flex',
          flexWrap: 'wrap',
          fontSize: theme.FontSizes.MEDIUM,
          width: '100%'
        },
        rangeOption: {
          alignItems: 'center',
          backgroundColor: 'transparent',
          border: 'none',
          boxSizing: 'border-box',
          color: theme.Colors.GRAY_700,
          cursor: 'pointer',
          display: 'flex',
          padding: "".concat(theme.Spacing.SMALL, "px ").concat(theme.Spacing.SMALL, "px"),
          width: '50%',
          fontSize: theme.FontSizes.SMALL,
          '&:hover': {
            backgroundColor: theme.Colors.GRAY_100
          },
          '&:focus': {
            backgroundColor: theme.Colors.GRAY_100
          }
        },
        rangeOptionIcon: {
          paddingRight: theme.Spacing.SMALL
        }
      };
    });
    return _this;
  }
  _createClass(SelectionPane, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      moment.locale(this.props.locale);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;
      var theme = StyleUtils.mergeTheme(this.props.theme);
      var styles = this.styles(theme);
      var _this$props = this.props,
        getTranslation = _this$props.getTranslation,
        selectedStartDate = _this$props.selectedStartDate,
        selectedEndDate = _this$props.selectedEndDate;
      return /*#__PURE__*/React.createElement("div", {
        className: "mx-selection-pane",
        style: styles.container
      }, /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("label", {
        style: styles.boxLabel
      }, getTranslation('From')), /*#__PURE__*/React.createElement("button", {
        "aria-label": getTranslation("Select Start Date".concat(selectedStartDate ? ', Current start date is' : '', " %1"), this._formatDate(selectedStartDate)),
        className: "mx-selection-pane-from-field",
        onClick: function onClick() {
          return _this2._handleDateBoxClick(selectedStartDate, SelectedBox.FROM);
        },
        ref: this.props.getFromButtonRef,
        style: _objectSpread(_objectSpread({}, styles.dateSelectBox), this.props.selectedBox === SelectedBox.FROM ? styles.selectedDateSelectBox : {})
      }, selectedStartDate ? this._formatDate(selectedStartDate) : getTranslation('Select Start Date')), /*#__PURE__*/React.createElement("label", {
        style: styles.boxLabel
      }, getTranslation('To')), /*#__PURE__*/React.createElement("button", {
        "aria-label": getTranslation("Select End Date".concat(selectedEndDate ? ', Current end date is' : '', " %1"), this._formatDate(selectedEndDate)),
        className: "mx-selection-pane-to-field",
        onClick: function onClick() {
          return _this2._handleDateBoxClick(selectedEndDate, SelectedBox.TO);
        },
        ref: this.props.getToButtonRef,
        style: _objectSpread(_objectSpread({}, styles.dateSelectBox), this.props.selectedBox === SelectedBox.TO ? styles.selectedDateSelectBox : {})
      }, selectedEndDate ? this._formatDate(selectedEndDate) : getTranslation('Select End Date'))), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("div", {
        style: _objectSpread(_objectSpread({}, styles.defaultRangesTitle), {}, {
          color: theme.Colors.PRIMARY
        })
      }, getTranslation('Select a Range')), /*#__PURE__*/React.createElement(DefaultRanges, _extends({}, this.props, {
        styles: styles,
        theme: theme
      }))));
    }
  }]);
  return SelectionPane;
}(React.Component);
_defineProperty(SelectionPane, "propTypes", {
  currentDate: PropTypes.string,
  defaultRanges: PropTypes.array,
  getFromButtonRef: PropTypes.func,
  getToButtonRef: PropTypes.func,
  getTranslation: PropTypes.func,
  locale: PropTypes.string,
  onDateBoxClick: PropTypes.func,
  selectedBox: PropTypes.string,
  selectedEndDate: PropTypes.number,
  selectedStartDate: PropTypes.number,
  setCurrentDate: PropTypes.func,
  theme: themeShape
});
module.exports = (0, _Theme.withTheme)(SelectionPane);