"use strict";

var _cssinjs = require("@mxenabled/cssinjs");
var _Theme = require("./Theme");
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var _get = require('lodash/get');
var _isEqual = require('lodash/isEqual');
var _isNumber = require('lodash/isNumber');
var _merge = require('lodash/merge');
var _throttle = require('lodash/throttle');
var _uniqueId = require('lodash/uniqueId');
var keycode = require('keycode');
var PropTypes = require('prop-types');
var React = require('react');
var Velocity = require('velocity-animate');
var Button = require('../components/Button');
var MXFocusTrap = require('../components/MXFocusTrap');
var _require = require('../constants/App'),
  themeShape = _require.themeShape;
var StyleUtils = require('../utils/Style');
var Drawer = /*#__PURE__*/function (_React$Component) {
  _inherits(Drawer, _React$Component);
  var _super = _createSuper(Drawer);
  function Drawer(props) {
    var _this;
    _classCallCheck(this, Drawer);
    _this = _super.call(this, props);
    _defineProperty(_assertThisInitialized(_this), "_getAnimationDistance", function () {
      if (_isNumber(_this.props.animateLeftDistance)) {
        return _this.props.animateLeftDistance + '%';
      }
      var windowWidth = window.innerWidth;
      if (windowWidth >= _this.state.breakPoints.large) {
        //Resolution - maxWidth
        return windowWidth - _this.props.maxWidth;
      } else if (windowWidth <= _this.state.breakPoints.medium) {
        //All the way over to the left
        return 0;
      } else {
        //20% from the left
        var newLeft = windowWidth * 0.2;
        return Math.max(newLeft, windowWidth - _this.props.maxWidth);
      }
    });
    _defineProperty(_assertThisInitialized(_this), "_getExposedDrawerFunctions", function () {
      return {
        close: _this.close
      };
    });
    /**
     * Figure out the height of the header. This can come from either:
     *
     * this.props.headerStyle.height
     * this.props.header.height
     *
     * If neither are set, default to 50px
     */
    _defineProperty(_assertThisInitialized(_this), "_getHeaderHeight", function () {
      return _get(_this.props, ['headerStyle', 'height'], _get(_this.props, ['styles', 'header', 'height'], '50px'));
    });
    /**
     * Animate the Drawer closed and then call the onClose callback.
     *
     * @returns {Promise} that is resolved when the animation finishes
     */
    _defineProperty(_assertThisInitialized(_this), "close", function () {
      _this.props.beforeClose();
      if (_this.props.animateOnClose) {
        return _this._animateComponent({
          left: '100%'
        }).then(function () {
          _this.props.onClose();
        });
      } else {
        // To keep close's api normalized we return a promise just
        // as the _animateComponent function does above.
        return Promise.resolve().then(function () {
          _this.props.onClose();
        });
      }
    });
    _defineProperty(_assertThisInitialized(_this), "open", function () {
      return _this._animateComponent({
        left: _this._getAnimationDistance()
      }).then(function () {
        _this.props.onOpen();
      });
    });
    _defineProperty(_assertThisInitialized(_this), "_animateComponent", function (transition, extraOptions) {
      var el = _this._component;
      var options = _extends({
        duration: _this.props.duration,
        easing: _this.props.easing
      }, extraOptions);
      return Velocity(el, transition, options);
    });
    _defineProperty(_assertThisInitialized(_this), "_handleKeyUp", function (e) {
      if (keycode(e) === 'esc') {
        e.preventDefault();
        e.stopPropagation();
        _this.close();
      }
    });
    _defineProperty(_assertThisInitialized(_this), "_resize", function () {
      _this._animateComponent({
        left: _this._getAnimationDistance()
      }, {
        duration: 0
      });
    });
    _defineProperty(_assertThisInitialized(_this), "styles", function (theme) {
      var _component;
      var HEADER_HEIGHT = _this._getHeaderHeight();
      return _merge({}, {
        component: (_component = {
          border: '1px solid ' + theme.Colors.GRAY_300,
          boxSizing: 'border-box',
          zIndex: 1001,
          top: 0,
          bottom: 0,
          left: '100%',
          position: 'absolute',
          width: '80%',
          backgroundColor: theme.Colors.GRAY_100,
          boxShadow: theme.ShadowHigh
        }, _defineProperty(_component, "@media (max-width: ".concat(_this.state.breakPoints.medium, "px)"), {
          width: '100%'
        }), _defineProperty(_component, "@media (min-width: ".concat(_this.state.breakPoints.large, "px)"), {
          width: _this.props.maxWidth
        }), _component),
        componentWrapper: {
          bottom: 0,
          left: 0,
          position: 'fixed',
          right: 0,
          top: 0,
          zIndex: 999
        },
        content: {
          backgroundColor: theme.Colors.WHITE,
          overflow: 'auto',
          height: "calc(100% - ".concat(HEADER_HEIGHT, ")")
        },
        scrim: {
          zIndex: 1000,
          position: 'fixed',
          top: 0,
          right: 0,
          bottom: 0,
          left: 0,
          textAlign: 'center',
          backgroundColor: _this.props.showScrim ? theme.Colors.SCRIM : 'transparent'
        },
        icons: {
          color: theme.Colors.GRAY_500
        },
        backArrow: {
          textAlign: 'left',
          width: '25%'
        },
        header: _defineProperty({
          alignItems: 'center',
          backgroundColor: theme.Colors.WHITE,
          borderBottom: 'solid 1px ' + theme.Colors.GRAY_300,
          color: theme.Colors.GRAY_500,
          display: 'flex',
          fontFamily: theme.Fonts.REGULAR,
          fontSize: theme.FontSizes.LARGE,
          justifyContent: 'center',
          padding: '0 20px',
          position: 'relative',
          height: HEADER_HEIGHT,
          boxSizing: 'border-box'
        }, "@media (max-width: ".concat(_this.state.breakPoints.medium, "px)"), {
          padding: '0 10px'
        }),
        title: {
          flex: '1 0 auto',
          maxWidth: '90%',
          overflow: 'hidden',
          textAlign: 'center',
          textOverflow: 'ellipsis',
          whiteSpace: 'nowrap'
        },
        headerMenu: {
          textAlign: 'right',
          whiteSpace: 'nowrap',
          width: '25%'
        }
      }, _this.props.styles);
    });
    var _theme = StyleUtils.mergeTheme(props.theme);
    var breakPoints = props.breakPoints || _theme.BreakPoints;
    _this.state = {
      breakPoints: breakPoints,
      theme: _theme
    };
    return _this;
  }
  _createClass(Drawer, [{
    key: "UNSAFE_componentWillMount",
    value: function UNSAFE_componentWillMount() {
      this._resizeThrottled = _throttle(this._resize, 100);
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.open();
      window.addEventListener('resize', this._resizeThrottled);
      if (this.props.focusOnLoad) {
        // Close button might not be present depending on showCloseButton Prop
        if (this.props.showCloseButton && this._closeButton) {
          this._closeButton.focus();
          // Fall back to focusing the component if no close button
        } else if (this._component) {
          this._component.focus();
        }
      }
    }
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(newProps) {
      if (!_isEqual(newProps.breakPoints, this.props.breakPoints)) {
        this.setState({
          breakPoints: this.props.breakPoints
        });
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      window.removeEventListener('resize', this._resizeThrottled);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;
      var theme = this.state.theme;
      var styles = this.styles(theme);
      var _this$props = this.props,
        closeButtonAriaLabel = _this$props.closeButtonAriaLabel,
        headerMenu = _this$props.headerMenu,
        focusTrapProps = _this$props.focusTrapProps,
        getTranslation = _this$props.getTranslation,
        portalTo = _this$props.portalTo;
      var mergedFocusTrapProps = _objectSpread({
        focusTrapOptions: {
          clickOutsideDeactivates: true,
          portalTo: portalTo
        },
        paused: false
      }, focusTrapProps);
      var menu = typeof headerMenu === 'function' ? headerMenu(this._getExposedDrawerFunctions()) : headerMenu;
      var titleUniqueId = _uniqueId('mx-drawer-title-');
      return /*#__PURE__*/React.createElement(MXFocusTrap, mergedFocusTrapProps, /*#__PURE__*/React.createElement("div", {
        className: "mx-drawer",
        onKeyUp: typeof this.props.onKeyUp === 'function' ? this.props.onKeyUp : this._handleKeyUp,
        style: styles.componentWrapper
      }, /*#__PURE__*/React.createElement("div", {
        className: "mx-drawer-scrim",
        onClick: function onClick() {
          if (_this2.props.closeOnScrimClick) _this2.close();
        },
        style: styles.scrim
      }), /*#__PURE__*/React.createElement("div", {
        "aria-describedby": this.props['aria-describedby'],
        "aria-labelledby": this.props['aria-labelledby'] || titleUniqueId,
        className: (0, _cssinjs.css)(_objectSpread(_objectSpread({}, styles.component), this.props.style)),
        ref: function ref(_ref) {
          return _this2._component = _ref;
        },
        role: this.props.role,
        tabIndex: 0
      }, /*#__PURE__*/React.createElement("header", {
        className: "mx-drawer-header ".concat((0, _cssinjs.css)(_objectSpread(_objectSpread({}, styles.header), this.props.headerStyle)))
      }, /*#__PURE__*/React.createElement("span", {
        style: styles.backArrow
      }, this.props.showCloseButton && /*#__PURE__*/React.createElement(Button, {
        "aria-label": closeButtonAriaLabel || getTranslation('Close %1 Drawer', this.props.title),
        buttonRef: function buttonRef(ref) {
          return _this2._closeButton = ref;
        },
        className: "mx-drawer-close",
        icon: "go-back",
        onClick: this.close,
        theme: theme,
        type: 'base'
      })), /*#__PURE__*/React.createElement("h2", {
        id: titleUniqueId,
        style: styles.title
      }, this.props.title), /*#__PURE__*/React.createElement("div", {
        className: "mx-drawer-header-menu",
        style: styles.headerMenu
      }, menu)), /*#__PURE__*/React.createElement("div", {
        className: "mx-drawer-content",
        style: _objectSpread(_objectSpread({}, styles.content), this.props.contentStyle)
      }, typeof this.props.children === 'function' ? this.props.children(this._getExposedDrawerFunctions()) : this.props.children))));
    }
  }]);
  return Drawer;
}(React.Component);
_defineProperty(Drawer, "propTypes", {
  animateLeftDistance: PropTypes.number,
  animateOnClose: PropTypes.bool,
  'aria-describedby': PropTypes.string,
  'aria-labelledby': PropTypes.string,
  beforeClose: PropTypes.func,
  breakPoints: PropTypes.shape({
    large: PropTypes.number,
    medium: PropTypes.number
  }),
  closeButtonAriaLabel: PropTypes.string,
  closeOnScrimClick: PropTypes.bool,
  contentStyle: PropTypes.oneOfType([PropTypes.array, PropTypes.object]),
  duration: PropTypes.number,
  easing: PropTypes.array,
  focusOnLoad: PropTypes.bool,
  focusTrapProps: PropTypes.object,
  getTranslation: PropTypes.func,
  headerMenu: PropTypes.oneOfType([PropTypes.element, PropTypes.func]),
  headerStyle: PropTypes.oneOfType([PropTypes.array, PropTypes.object]),
  maxWidth: PropTypes.number,
  onClose: PropTypes.func.isRequired,
  onKeyUp: PropTypes.func,
  onOpen: PropTypes.func,
  portalTo: PropTypes.string,
  role: PropTypes.string,
  showCloseButton: PropTypes.bool,
  showScrim: PropTypes.bool,
  styles: PropTypes.object,
  theme: themeShape,
  title: PropTypes.string
});
_defineProperty(Drawer, "defaultProps", {
  animateOnClose: true,
  beforeClose: function beforeClose() {},
  closeOnScrimClick: true,
  duration: 500,
  easing: [0.28, 0.14, 0.34, 1.04],
  focusOnLoad: true,
  focusTrapProps: {},
  maxWidth: 960,
  onOpen: function onOpen() {},
  role: 'dialog',
  showCloseButton: true,
  showScrim: true,
  title: ''
});
module.exports = (0, _Theme.withTheme)(Drawer);