"use strict";

var _Theme = require("./Theme");
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var PropTypes = require('prop-types');
var React = require('react');
var _merge = require('lodash/merge');
var Spin = require('./Spin');
var _require = require('../constants/App'),
  themeShape = _require.themeShape;
var StyleUtils = require('../utils/Style');
var Loader = /*#__PURE__*/function (_React$Component) {
  _inherits(Loader, _React$Component);
  var _super = _createSuper(Loader);
  function Loader() {
    var _this;
    _classCallCheck(this, Loader);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    _defineProperty(_assertThisInitialized(_this), "styles", function (theme) {
      var color = _this.props.color || theme.Colors.PRIMARY;
      var componentStyles = {
        component: {
          backgroundColor: 'rgba(255,255,255,0.9)',
          bottom: 0,
          color: '#999',
          fontFamily: theme.Fonts.REGULAR,
          fontSize: '10px',
          fontWeight: 600,
          left: 0,
          letterSpacing: '1px',
          position: _this.props.isRelative ? 'absolute' : 'fixed',
          right: 0,
          textAlign: 'center',
          top: 0,
          zIndex: 100
        },
        content: {
          textAlign: 'center',
          position: 'absolute',
          top: 0,
          right: 0,
          bottom: 0,
          left: 0,
          margin: 'auto',
          width: _this.props.isSmall ? '30px' : '50px',
          height: _this.props.isSmall ? '30px' : '50px'
        },
        circle: {
          borderRadius: '100%',
          width: _this.props.isSmall ? '30px' : '50px',
          height: _this.props.isSmall ? '30px' : '50px',
          borderTop: '3px solid ' + color,
          borderRight: '3px solid transparent',
          borderBottom: '3px solid transparent',
          borderLeft: '3px solid transparent'
        },
        text: {
          marginTop: '10px',
          fontSize: '10px'
        }
      };
      return _this.props.styles ? _merge({}, componentStyles, _this.props.styles) : componentStyles;
    });
    return _this;
  }
  _createClass(Loader, [{
    key: "render",
    value: function render() {
      var theme = StyleUtils.mergeTheme(this.props.theme);
      var styles = this.styles(theme);
      if (this.props.isLoading) {
        return /*#__PURE__*/React.createElement("div", {
          className: "mx-loader",
          style: styles.component
        }, /*#__PURE__*/React.createElement("div", {
          className: "mx-loader-content",
          style: styles.content
        }, /*#__PURE__*/React.createElement(Spin, {
          direction: this.props.direction
        }, /*#__PURE__*/React.createElement("div", {
          style: styles.circle
        })), this.props.isSmall ? null : /*#__PURE__*/React.createElement("div", {
          className: "mx-loader-text",
          style: styles.text
        }, " ", this.props.children, " ")));
      } else {
        return /*#__PURE__*/React.createElement("div", null);
      }
    }
  }]);
  return Loader;
}(React.Component);
_defineProperty(Loader, "propTypes", {
  color: PropTypes.string,
  direction: PropTypes.oneOf(['counterclockwise', 'clockwise']),
  isLoading: PropTypes.bool,
  isRelative: PropTypes.bool,
  isSmall: PropTypes.bool,
  styles: PropTypes.object,
  theme: themeShape
});
_defineProperty(Loader, "defaultProps", {
  direction: 'clockwise',
  isLoading: false,
  isRelative: false,
  isSmall: false,
  children: 'LOADING...'
});
module.exports = (0, _Theme.withTheme)(Loader);