"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var traps = [];
var PropTypes = require('prop-types');
var React = require('react');
var ReactDOM = require('react-dom');
var FocusTrap = require('focus-trap-react');
var _get = require('lodash/get');

/**
 * MXFocusTrap
 *
 * Why is this needed?
 *
 * FocusTrap does not un-pause the previous trap when the current trap is unmounted.
 * This ensures that the previously trapped component is un-paused.
 */
var MXFocusTrap = /*#__PURE__*/function (_React$Component) {
  _inherits(MXFocusTrap, _React$Component);
  var _super = _createSuper(MXFocusTrap);
  function MXFocusTrap() {
    var _this;
    _classCallCheck(this, MXFocusTrap);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    _defineProperty(_assertThisInitialized(_this), "state", {
      paused: false
    });
    _defineProperty(_assertThisInitialized(_this), "_getSiblingNodeToRenderNextTo", function (queryString) {
      if (!queryString || typeof queryString !== 'string') {
        return null;
      }
      return document.querySelector(queryString);
    });
    _defineProperty(_assertThisInitialized(_this), "_safelySetNodeAriaHiddenAttribute", function (node, state) {
      if (node && node.setAttribute) {
        node.setAttribute('aria-hidden', state);
      }
    });
    return _this;
  }
  _createClass(MXFocusTrap, [{
    key: "UNSAFE_componentWillMount",
    value: function UNSAFE_componentWillMount() {
      var _this2 = this;
      // FocusTrap does it's own pausing but these React components also need to be paused
      traps.forEach(function (component) {
        component.setState({
          paused: true
        });
        _this2._safelySetNodeAriaHiddenAttribute(ReactDOM.findDOMNode(component), true);
      });
      traps.push(this);
      this._siblingNodeToRenderNextTo = this._getSiblingNodeToRenderNextTo(_get(this.props, 'focusTrapOptions.portalTo', null));
      this._safelySetNodeAriaHiddenAttribute(this._siblingNodeToRenderNextTo, true);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var _this3 = this;
      traps = traps.filter(function (component) {
        return component !== _this3;
      });
      var lastTrap = traps[traps.length - 1];
      if (lastTrap) {
        lastTrap.setState({
          paused: false
        });
        this._safelySetNodeAriaHiddenAttribute(ReactDOM.findDOMNode(lastTrap), false);
      } else {
        this._safelySetNodeAriaHiddenAttribute(this._siblingNodeToRenderNextTo, false);
      }
    }
  }, {
    key: "render",
    value: function render() {
      // Portal next to selected sibling
      if (this._siblingNodeToRenderNextTo && this._siblingNodeToRenderNextTo.parentNode) {
        return ReactDOM.createPortal( /*#__PURE__*/React.createElement(FocusTrap, _extends({}, this.props, {
          paused: this.state.paused
        }), this.props.children), this._siblingNodeToRenderNextTo.parentNode);
      }

      // Render in normal location
      return /*#__PURE__*/React.createElement(FocusTrap, _extends({}, this.props, {
        paused: this.state.paused
      }), this.props.children);
    }
  }]);
  return MXFocusTrap;
}(React.Component);
_defineProperty(MXFocusTrap, "propTypes", {
  focusTrapOptions: PropTypes.object
});
module.exports = MXFocusTrap;