"use strict";

var _Theme = require("./Theme");
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var PropTypes = require('prop-types');
var React = require('react');
var Icon = require('../components/Icon');
var _require = require('../constants/App'),
  themeShape = _require.themeShape;
var StyleUtils = require('../utils/Style');
var Menu = /*#__PURE__*/function (_React$Component) {
  _inherits(Menu, _React$Component);
  var _super = _createSuper(Menu);
  function Menu() {
    var _this;
    _classCallCheck(this, Menu);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    _defineProperty(_assertThisInitialized(_this), "state", {
      hoverItemIndex: null
    });
    _defineProperty(_assertThisInitialized(_this), "_handleMouseOver", function (hoverItemIndex) {
      _this.setState({
        hoverItemIndex: hoverItemIndex
      });
    });
    _defineProperty(_assertThisInitialized(_this), "_handleMouseOut", function () {
      _this.setState({
        hoverItemIndex: null
      });
    });
    _defineProperty(_assertThisInitialized(_this), "_renderItems", function (styles, theme) {
      return _this.props.items.map(function (item, index) {
        return /*#__PURE__*/React.createElement("div", {
          key: item.label,
          onClick: item.onClick,
          onMouseOut: _this._handleMouseOut,
          onMouseOver: _this._handleMouseOver.bind(null, index),
          style: _extends({}, styles.menuItem, {
            backgroundColor: index === _this.state.hoverItemIndex ? theme.Colors.PRIMARY : 'transparent',
            color: index === _this.state.hoverItemIndex ? theme.Colors.WHITE : theme.Colors.GRAY_500
          })
        }, /*#__PURE__*/React.createElement(Icon, {
          size: 20,
          style: _extends({}, styles.itemIcon, {
            fill: index === _this.state.hoverItemIndex ? theme.Colors.WHITE : theme.Colors.GRAY_700
          }),
          type: item.icon
        }), /*#__PURE__*/React.createElement("span", {
          style: styles.itemLabel
        }, item.label));
      });
    });
    _defineProperty(_assertThisInitialized(_this), "styles", function (theme) {
      return {
        component: {
          display: 'block',
          position: 'relative',
          width: 40
        },
        dotsWrapper: {
          backgroundColor: _this.props.isOpen ? theme.Colors.GRAY_100 : 'transparent',
          border: '1px solid ' + theme.Colors.GRAY_300,
          borderRadius: 3,
          cursor: 'pointer',
          margin: 3,
          padding: 6
        },
        menu: {
          backgroundColor: theme.Colors.WHITE,
          border: '1px solid ' + theme.Colors.GRAY_300,
          borderRadius: 3,
          boxShadow: theme.ShadowHigh,
          position: 'absolute',
          top: 40,
          padding: 10,
          maxWidth: 260,
          zIndex: 10
        },
        menuIcon: {
          fill: theme.Colors.PRIMARY
        },
        menuItem: {
          color: theme.Colors.GRAY_500,
          cursor: 'pointer',
          marginRight: 5,
          whiteSpace: 'nowrap'
        },
        itemIcon: {
          padding: '10px 5px',
          opacity: 0.5
        },
        itemLabel: {
          paddingRight: 10,
          position: 'relative',
          top: 3
        }
      };
    });
    return _this;
  }
  _createClass(Menu, [{
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      if (!nextProps.isOpen) {
        this.setState({
          hoverItemIndex: null
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
        isOpen = _this$props.isOpen,
        alignItems = _this$props.alignItems;
      var theme = StyleUtils.mergeTheme(this.props.theme);
      var styles = this.styles(theme);
      return /*#__PURE__*/React.createElement("div", {
        className: "mx-menu",
        onClick: this.props.onClick,
        style: _extends({}, styles.component, this.props.style)
      }, /*#__PURE__*/React.createElement("div", {
        style: styles.dotsWrapper
      }, /*#__PURE__*/React.createElement(Icon, {
        size: 20,
        style: styles.menuIcon,
        type: "kabob_horizontal"
      })), isOpen ? /*#__PURE__*/React.createElement("div", {
        className: "mx-menu-open",
        style: _extends({}, styles.menu, alignItems === 'right' ? {
          right: 3
        } : {
          left: 3
        })
      }, this._renderItems(styles, theme)) : null);
    }
  }]);
  return Menu;
}(React.Component);
_defineProperty(Menu, "propTypes", {
  alignItems: PropTypes.oneOf(['left', 'right']),
  isOpen: PropTypes.bool,
  items: PropTypes.arrayOf(PropTypes.shape({
    icon: PropTypes.string,
    label: PropTypes.string,
    onClick: PropTypes.func
  })).isRequired,
  onClick: PropTypes.func,
  theme: themeShape
});
_defineProperty(Menu, "defaultProps", {
  alignItems: 'left',
  isOpen: false,
  onClick: function onClick() {}
});
module.exports = (0, _Theme.withTheme)(Menu);