"use strict";

var _Theme = require("./Theme");
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var PropTypes = require('prop-types');
var React = require('react');
var _merge = require('lodash/merge');
var _isNil = require('lodash/isNil');
var Icon = require('../components/Icon');
var _require = require('../constants/App'),
  themeShape = _require.themeShape;
var StyleUtils = require('../utils/Style');
var MessageBox = /*#__PURE__*/function (_React$Component) {
  _inherits(MessageBox, _React$Component);
  var _super = _createSuper(MessageBox);
  function MessageBox() {
    var _this;
    _classCallCheck(this, MessageBox);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    _defineProperty(_assertThisInitialized(_this), "styles", function (theme) {
      var color = _this.props.color || theme.Colors.PRIMARY;
      return _merge({}, {
        component: {
          color: theme.Colors.GRAY_900,
          boxShadow: theme.ShadowMed,
          boxSizing: 'border-box',
          borderTop: 'none',
          borderRadius: 4,
          display: 'flex',
          flexDirection: 'column'
        },
        alertbar: {
          background: color,
          color: theme.Colors.GRAY_900,
          borderColor: "".concat(color, " ").concat(theme.Colors.GRAY_300, " ").concat(theme.Colors.GRAY_300, " ").concat(theme.Colors.GRAY_300),
          borderTopWidth: '1px',
          borderTopStyle: 'solid',
          borderTopLeftRadius: 4,
          borderTopRightRadius: 4,
          height: 5
        },
        button: {
          marginTop: _this.props.isSmall ? 10 : null,
          whiteSpace: 'nowrap',
          alignSelf: _this.props.isSmall ? null : 'flex-end',
          textAlign: _this.props.isSmall ? 'center' : null
        },
        header: {
          display: 'flex',
          padding: theme.Spacing.SMALL,
          paddingBottom: 0
        },
        icon: {
          fill: theme.Colors.GRAY_900,
          marginRight: theme.Spacing.SMALL
        },
        title: {
          fontFamily: theme.Fonts.SEMIBOLD,
          fontSize: theme.FontSizes.MEDIUM,
          marginBottom: 0
        },
        messageBody: {
          alignItems: 'baseline',
          display: 'flex',
          flex: '1 1 auto'
        },
        messageContent: {
          boxSizing: _this.props.isSmall ? null : 'content-box',
          textAlign: 'left',
          width: _this.props.isSmall || _this.props.children ? '100%' : '75%',
          paddingRight: _this.props.isSmall ? 30 : null,
          fontSize: theme.FontSizes.MEDIUM
        },
        message: {
          fontSize: theme.FontSizes.MEDIUM,
          marginBottom: 0
        },
        messageWrapper: {
          display: 'flex',
          flexDirection: _this.props.isSmall ? 'column' : 'row',
          padding: theme.Spacing.SMALL
        }
      }, _this.props.styles);
    });
    return _this;
  }
  _createClass(MessageBox, [{
    key: "render",
    value: function render() {
      var theme = StyleUtils.mergeTheme(this.props.theme);
      var styles = this.styles(theme);
      return /*#__PURE__*/React.createElement("article", {
        "aria-live": this.props.ariaLive,
        className: "mx-message-box",
        role: "region",
        style: styles.component
      }, /*#__PURE__*/React.createElement("div", {
        style: styles.alertbar
      }), /*#__PURE__*/React.createElement("div", {
        style: styles.messageWrapper
      }, /*#__PURE__*/React.createElement("div", {
        style: styles.messageBody
      }, /*#__PURE__*/React.createElement("section", null, /*#__PURE__*/React.createElement(Icon, {
        size: 20,
        style: styles.icon,
        type: this.props.icon
      })), /*#__PURE__*/React.createElement("section", {
        role: this.props.contentRole,
        style: styles.messageContent
      }, /*#__PURE__*/React.createElement("p", {
        style: styles.title
      }, this.props.title), this.props.message ? /*#__PURE__*/React.createElement("p", {
        style: styles.message
      }, this.props.message) : null, this.props.children ? this.props.children : null)), !_isNil(this.props.button) && /*#__PURE__*/React.createElement("div", {
        style: styles.button
      }, this.props.button)));
    }
  }]);
  return MessageBox;
}(React.Component);
_defineProperty(MessageBox, "propTypes", {
  ariaLive: PropTypes.string,
  button: PropTypes.node,
  color: PropTypes.string,
  contentRole: PropTypes.string,
  icon: PropTypes.string,
  isSmall: PropTypes.bool,
  message: PropTypes.oneOfType([PropTypes.node, PropTypes.string]),
  styles: PropTypes.object,
  theme: themeShape,
  title: PropTypes.string
});
_defineProperty(MessageBox, "defaultProps", {
  ariaLive: 'polite',
  contentRole: 'status'
});
module.exports = (0, _Theme.withTheme)(MessageBox);