"use strict";

var _Theme = require("./Theme");
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var React = require('react');
var PropTypes = require('prop-types');
var Radium = require('radium');
var Icon = require('./Icon');
var _require = require('../constants/App'),
  themeShape = _require.themeShape;
var StyleUtils = require('../utils/Style');
var SelectFullScreen = /*#__PURE__*/function (_React$Component) {
  _inherits(SelectFullScreen, _React$Component);
  var _super = _createSuper(SelectFullScreen);
  function SelectFullScreen() {
    var _this;
    _classCallCheck(this, SelectFullScreen);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    _defineProperty(_assertThisInitialized(_this), "state", {
      isOpen: false,
      selected: false
    });
    _defineProperty(_assertThisInitialized(_this), "_handleClick", function () {
      _this.setState({
        isOpen: true
      });
    });
    _defineProperty(_assertThisInitialized(_this), "_handleCloseClick", function () {
      _this.setState({
        isOpen: false
      });
    });
    _defineProperty(_assertThisInitialized(_this), "_handleOptionClick", function (option) {
      _this.setState({
        selected: option,
        isOpen: false
      });
      _this.props.onChange(option);
    });
    _defineProperty(_assertThisInitialized(_this), "_handleSelectChange", function (e) {
      var selectedOption = _this.props.options.filter(function (option) {
        return option.value + '' === e.target.value;
      })[0];
      _this._handleOptionClick(selectedOption);
    });
    _defineProperty(_assertThisInitialized(_this), "_optionFormatter", function (option, styles) {
      return /*#__PURE__*/React.createElement("div", {
        key: option.displayValue + option.value + '_value',
        style: styles.option
      }, option.displayValue);
    });
    _defineProperty(_assertThisInitialized(_this), "_renderOptions", function (styles) {
      if (_this.state.isOpen) {
        return /*#__PURE__*/React.createElement("div", {
          style: [styles.optionsScrim, _this.props.isFixed && {
            position: 'fixed'
          }]
        }, /*#__PURE__*/React.createElement("div", {
          onClick: _this._handleCloseClick,
          style: styles.close
        }, /*#__PURE__*/React.createElement(Icon, {
          size: 20,
          style: styles.closeIcon,
          type: _this.props.closeIcon
        }), /*#__PURE__*/React.createElement("div", {
          style: styles.closeText
        }, "ESC")), /*#__PURE__*/React.createElement("div", {
          style: styles.content
        }, /*#__PURE__*/React.createElement("div", {
          style: styles.optionsHeader
        }, _this.props.optionsHeaderText), /*#__PURE__*/React.createElement("div", {
          className: "mx-select-full-screen-options",
          style: [styles.optionsWrapper, _this.props.optionsStyle]
        }, _this.props.options.map(function (option) {
          return /*#__PURE__*/React.createElement("div", {
            className: "mx-select-full-screen-option",
            key: option.displayValue + option.value,
            onClick: _this._handleOptionClick.bind(null, option)
          }, _this.props.optionFormatter ? _this.props.optionFormatter(option) : _this._optionFormatter(option, styles));
        }))));
      } else {
        return null;
      }
    });
    _defineProperty(_assertThisInitialized(_this), "styles", function (theme) {
      return {
        close: {
          position: 'absolute',
          right: 20,
          top: 15,
          textAlign: 'center',
          cursor: 'pointer',
          color: theme.Colors.GRAY_500
        },
        closeIcon: {
          color: theme.Colors.GRAY_500
        },
        closeText: {
          fontSize: theme.FontSizes.TINY
        },
        component: {
          cursor: 'pointer',
          fontFamily: theme.FontFamily,
          fontSize: theme.FontSizes.LARGE,
          color: theme.Colors.GRAY_700,
          boxSizing: 'border-box',
          outline: 'none'
        },
        content: {
          left: '50%',
          position: 'absolute',
          top: '50%',
          transform: 'translate(-50%, -50%)',
          width: 300
        },
        optionsScrim: {
          backgroundColor: '#fff',
          bottom: 0,
          height: '100%',
          left: 0,
          position: 'absolute',
          right: 0,
          top: 0,
          zIndex: 999
        },
        optionsWrapper: {
          border: '1px solid ' + theme.Colors.GRAY_300,
          height: 250,
          overflow: 'auto',
          width: 300
        },
        option: {
          cursor: 'pointer',
          backgroundColor: '#fff',
          padding: 10,
          whiteSpace: 'nowrap',
          fontSize: theme.FontSizes.MEDIUM,
          ':hover': {
            backgroundColor: theme.Colors.PRIMARY,
            color: theme.Colors.WHITE,
            opacity: 1
          }
        },
        optionsHeader: {
          color: theme.Colors.GRAY_700,
          fontSize: theme.FontSizes.XXLARGE,
          fontWeight: 'bold',
          paddingBottom: 10
        }
      };
    });
    return _this;
  }
  _createClass(SelectFullScreen, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;
      window.onkeyup = function (e) {
        if (e.keyCode === 27) {
          _this2._handleCloseClick();
        }
      };
    }
  }, {
    key: "render",
    value: function render() {
      var theme = StyleUtils.mergeTheme(this.props.theme);
      var styles = this.styles(theme);
      var selected = this.state.selected || this.props.selected || {
        displayValue: this.props.placeholderText,
        value: ''
      };
      return /*#__PURE__*/React.createElement("div", {
        className: "mx-select-full-screen",
        ref: this.props.elementRef,
        style: [styles.component, this.props.style]
      }, /*#__PURE__*/React.createElement("div", {
        className: "mx-select-full-screen-selected",
        key: "selected",
        onClick: this._handleClick,
        style: this.props.selectedStyle
      }, selected.displayValue), this._renderOptions(styles));
    }
  }]);
  return SelectFullScreen;
}(React.Component);
_defineProperty(SelectFullScreen, "propTypes", {
  closeIcon: PropTypes.string,
  elementRef: PropTypes.func,
  isFixed: PropTypes.bool,
  onChange: PropTypes.func,
  optionFormatter: PropTypes.func,
  options: PropTypes.array,
  optionsHeaderText: PropTypes.string,
  optionsStyle: PropTypes.oneOfType([PropTypes.object, PropTypes.array]),
  optionStyle: PropTypes.oneOfType([PropTypes.object, PropTypes.array]),
  placeholderText: PropTypes.string,
  selected: PropTypes.object,
  selectedStyle: PropTypes.oneOfType([PropTypes.object, PropTypes.array]),
  theme: themeShape
});
_defineProperty(SelectFullScreen, "defaultProps", {
  closeIcon: 'close',
  isFixed: false,
  onChange: function onChange() {},
  options: [],
  optionsHeaderText: 'Select An Option',
  placeholderText: 'Select One',
  selected: false
});
module.exports = (0, _Theme.withTheme)(Radium(SelectFullScreen));