"use strict";

var _Theme = require("./Theme");
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var PropTypes = require('prop-types');
var React = require('react');
var _merge = require('lodash/merge');
var _require = require('../constants/App'),
  themeShape = _require.themeShape;
var StyleUtils = require('../utils/Style');
var SimpleInput = /*#__PURE__*/function (_React$Component) {
  _inherits(SimpleInput, _React$Component);
  var _super = _createSuper(SimpleInput);
  function SimpleInput() {
    var _this;
    _classCallCheck(this, SimpleInput);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    _defineProperty(_assertThisInitialized(_this), "state", {
      focus: false
    });
    _defineProperty(_assertThisInitialized(_this), "_onFocus", function (e) {
      _this.setState({
        focus: true
      });
      if (_this.props.elementProps.onFocus) _this.props.elementProps.onFocus(e);
    });
    _defineProperty(_assertThisInitialized(_this), "_onBlur", function (e) {
      _this.setState({
        focus: false
      });
      if (_this.props.elementProps.onBlur) _this.props.elementProps.onBlur(e);
    });
    _defineProperty(_assertThisInitialized(_this), "styles", function (theme) {
      return _merge({}, {
        wrapper: _extends({}, {
          padding: theme.Spacing.SMALL,
          boxSizing: 'border-box',
          backgroundColor: theme.Colors.WHITE,
          border: _this.props.valid ? '1px solid ' + theme.Colors.GRAY_300 : '1px solid ' + theme.Colors.DANGER,
          borderRadius: 3,
          display: 'flex',
          alignItems: 'center',
          width: '100%',
          outline: 'none',
          boxShadow: 'none'
        }, _this.props.style),
        activeWrapper: {
          border: '1px solid ' + theme.Colors.PRIMARY
        },
        input: {
          flex: '1 0 0%',
          color: theme.Colors.GRAY_700,
          fontSize: theme.FontSizes.MEDIUM,
          backgroundColor: theme.Colors.WHITE,
          border: 'none',
          outline: 'none',
          boxShadow: 'none'
        }
      }, _this.props.styles);
    });
    return _this;
  }
  _createClass(SimpleInput, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.focusOnLoad && this.elementRef) {
        this.elementRef.focus();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props = this.props,
        elementProps = _this$props.elementProps,
        prefix = _this$props.prefix,
        suffix = _this$props.suffix;
      var theme = StyleUtils.mergeTheme(this.props.theme);
      var styles = this.styles(theme);
      return /*#__PURE__*/React.createElement("div", {
        className: "mx-simple-input",
        style: this.state.focus ? _objectSpread(_objectSpread({}, styles.wrapper), styles.activeWrapper) : styles.wrapper
      }, prefix ? prefix : null, /*#__PURE__*/React.createElement("input", _extends({}, elementProps, {
        onBlur: this._onBlur,
        onFocus: this._onFocus,
        ref: function ref(_ref) {
          _this2.elementRef = _ref;
          if (typeof _this2.props.elementRef === 'function') _this2.props.elementRef(_ref);
        },
        style: styles.input,
        type: this.props.type
      })), suffix ? suffix : null);
    }
  }]);
  return SimpleInput;
}(React.Component);
_defineProperty(SimpleInput, "propTypes", {
  elementProps: PropTypes.object,
  elementRef: PropTypes.func,
  focusOnLoad: PropTypes.bool,
  prefix: PropTypes.node,
  //keep style for backwards compatibility
  style: PropTypes.oneOfType([PropTypes.array, PropTypes.object]),
  styles: PropTypes.object,
  suffix: PropTypes.node,
  theme: themeShape,
  type: PropTypes.string,
  valid: PropTypes.bool
});
_defineProperty(SimpleInput, "defaultProps", {
  elementProps: {},
  focusOnLoad: false,
  type: 'text',
  valid: true
});
module.exports = (0, _Theme.withTheme)(SimpleInput);