"use strict";

var _Theme = require("./Theme");
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var React = require('react');
var PropTypes = require('prop-types');
var Radium = require('radium');
var Icon = require('./Icon');
var _require = require('../constants/App'),
  themeShape = _require.themeShape;
var StyleUtils = require('../utils/Style');
var ToggleSwitch = /*#__PURE__*/function (_React$Component) {
  _inherits(ToggleSwitch, _React$Component);
  var _super = _createSuper(ToggleSwitch);
  function ToggleSwitch() {
    var _this;
    _classCallCheck(this, ToggleSwitch);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    _defineProperty(_assertThisInitialized(_this), "_handleToggle", function (event) {
      _this.props.onToggle(event);
    });
    _defineProperty(_assertThisInitialized(_this), "styles", function (theme) {
      return _extends({}, {
        component: {
          alignItems: 'center',
          display: 'flex',
          fontFamily: theme.Fonts.REGULAR,
          fontSize: theme.FontSizes.MEDIUM,
          position: 'relative',
          border: 'none',
          background: 'transparent'
        },
        icon: {
          fill: theme.Colors.WHITE,
          position: 'absolute',
          top: 0,
          zIndex: 2
        },
        trueIcon: {
          left: 0
        },
        falseIcon: {
          right: 0
        },
        label: {
          cursor: 'pointer',
          fontWeight: 'bold'
        },
        inactiveLabel: {
          color: theme.Colors.GRAY_300
        },
        activeLabel: {
          color: theme.Colors.PRIMARY
        },
        toggle: {
          backgroundColor: theme.Colors.WHITE,
          borderRadius: '100%',
          height: 20,
          left: _this.props.checked ? 20 : 2,
          position: 'absolute',
          transition: 'all 0.5s ease',
          width: 20,
          zIndex: 3
        },
        track: {
          borderRadius: 20,
          boxSizing: 'border-box',
          cursor: 'pointer',
          height: 24,
          minHeight: 24,
          margin: '0 10px',
          padding: 2,
          position: 'relative',
          transition: 'all 0.5s ease',
          verticalAlign: 'middle',
          width: 42,
          minWidth: 42,
          zIndex: 1
        },
        trueTrack: {
          backgroundColor: theme.Colors.GRAY_700
        },
        falseTrack: {
          backgroundColor: theme.Colors.GRAY_500
        }
      }, _this.props.styles);
    });
    return _this;
  }
  _createClass(ToggleSwitch, [{
    key: "render",
    value: function render() {
      var theme = StyleUtils.mergeTheme(this.props.theme);
      var styles = this.styles(theme);
      return /*#__PURE__*/React.createElement("button", _extends({
        "aria-checked": this.props.checked,
        className: "toggle-switch-component",
        onClick: this._handleToggle,
        ref: this.props.elementRef,
        role: "switch",
        style: styles.component
      }, this.props.buttonProps), this.props.showLabels ? /*#__PURE__*/React.createElement("div", {
        className: "left-label",
        style: _extends({}, styles.label, this.props.checked ? styles.inactiveLabel : styles.activeLabel)
      }, this.props.leftLabel) : null, /*#__PURE__*/React.createElement("div", {
        className: "toggle-switch-track",
        style: _extends({}, styles.track, styles[this.props.checked + 'Track'])
      }, this.props.showIcons ? /*#__PURE__*/React.createElement("span", null, /*#__PURE__*/React.createElement(Icon, {
        className: "true-icon",
        style: _extends({}, styles.icon, styles.trueIcon),
        type: this.props.trueIcon
      }), /*#__PURE__*/React.createElement(Icon, {
        className: "false-icon",
        style: _extends({}, styles.icon, styles.falseIcon),
        type: this.props.falseIcon
      })) : null, /*#__PURE__*/React.createElement("div", {
        className: "toggle-switch-toggle",
        style: styles.toggle
      })), this.props.showLabels ? /*#__PURE__*/React.createElement("div", {
        className: "right-label",
        onClick: this._handleToggle,
        style: _extends({}, styles.label, this.props.checked ? styles.activeLabel : styles.inactiveLabel)
      }, this.props.rightLabel) : null);
    }
  }]);
  return ToggleSwitch;
}(React.Component);
_defineProperty(ToggleSwitch, "propTypes", {
  buttonProps: PropTypes.object,
  checked: PropTypes.bool,
  elementRef: PropTypes.func,
  falseIcon: PropTypes.string,
  leftLabel: PropTypes.string,
  onToggle: PropTypes.func,
  rightLabel: PropTypes.string,
  showIcons: PropTypes.bool,
  showLabels: PropTypes.bool,
  styles: PropTypes.object,
  theme: themeShape,
  trueIcon: PropTypes.string
});
_defineProperty(ToggleSwitch, "defaultProps", {
  checked: false,
  falseIcon: 'close-skinny',
  leftLabel: 'Off',
  onToggle: function onToggle() {},
  rightLabel: 'On',
  showLabels: false,
  showIcons: true,
  trueIcon: 'check-skinny'
});
module.exports = (0, _Theme.withTheme)(Radium(ToggleSwitch));