"use strict";

var _Theme = require("../Theme");
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var PropTypes = require('prop-types');
var React = require('react');
var d3 = require('d3');
var _require = require('../../constants/App'),
  themeShape = _require.themeShape;
var StyleUtils = require('../../utils/Style');
var LineGroup = /*#__PURE__*/function (_React$Component) {
  _inherits(LineGroup, _React$Component);
  var _super = _createSuper(LineGroup);
  function LineGroup() {
    var _this;
    _classCallCheck(this, LineGroup);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    _defineProperty(_assertThisInitialized(_this), "_animateLine", function () {
      if (_this.props.shouldAnimate) {
        d3.select(_this.chartLine).transition().attr('d', _this.state.line(_this.props.data));
      }
    });
    return _this;
  }
  _createClass(LineGroup, [{
    key: "UNSAFE_componentWillMount",
    value: function UNSAFE_componentWillMount() {
      var _this2 = this;
      var flatLine = d3.svg.line().x(function (d) {
        return _this2.props.xScaleValueFunction(d.x);
      }).y(function () {
        return _this2.props.adjustedHeight;
      });
      var line = d3.svg.line().x(function (d) {
        return _this2.props.xScaleValueFunction(d.x);
      }).y(function (d) {
        return _this2.props.yScaleValueFunction(d.y);
      });
      this.setState({
        flatLine: flatLine,
        line: line
      });
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this._animateLine();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      this._animateLine();
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;
      var theme = StyleUtils.mergeTheme(this.props.theme);
      var lineColor = this.props.lineColor || theme.Colors.GRAY_700;
      var _this$props = this.props,
        data = _this$props.data,
        dashLine = _this$props.dashLine,
        shouldAnimate = _this$props.shouldAnimate,
        strokeWidth = _this$props.strokeWidth,
        translation = _this$props.translation;
      return /*#__PURE__*/React.createElement("g", {
        className: "chart-line-group",
        transform: translation
      }, /*#__PURE__*/React.createElement("path", {
        d: shouldAnimate ? this.state.flatLine(data) : this.state.line(data),
        fill: "none",
        ref: function ref(_ref) {
          return _this3.chartLine = _ref;
        },
        stroke: lineColor,
        strokeDasharray: dashLine ? '4,4' : 'none',
        strokeWidth: strokeWidth
      }));
    }
  }]);
  return LineGroup;
}(React.Component);
_defineProperty(LineGroup, "propTypes", {
  adjustedHeight: PropTypes.number.isRequired,
  dashLine: PropTypes.bool,
  data: PropTypes.array.isRequired,
  lineColor: PropTypes.string,
  shouldAnimate: PropTypes.bool,
  strokeWidth: PropTypes.number,
  theme: themeShape,
  translation: PropTypes.string,
  xScaleValueFunction: PropTypes.func.isRequired,
  yScaleValueFunction: PropTypes.func.isRequired
});
_defineProperty(LineGroup, "defaultProps", {
  dashLine: false,
  shouldAnimate: true,
  strokeWidth: 2,
  translation: 'translate(0,0)'
});
module.exports = (0, _Theme.withTheme)(LineGroup);