"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var PropTypes = require('prop-types');
var React = require('react');
var defaultShape = {
  large: PropTypes.number,
  medium: PropTypes.number,
  small: PropTypes.number
};
var Column = /*#__PURE__*/function (_React$Component) {
  _inherits(Column, _React$Component);
  var _super = _createSuper(Column);
  function Column() {
    var _this;
    _classCallCheck(this, Column);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    _defineProperty(_assertThisInitialized(_this), "getColumnWidths", function () {
      var colWidths = [];
      var _this$props$span = _this.props.span,
        large = _this$props$span.large,
        medium = _this$props$span.medium,
        small = _this$props$span.small;

      // Column widths
      if (small === 0) {
        colWidths.push('hidden-sm');
      } else if (small) {
        colWidths.push('col-sm-' + small);
      }
      if (medium === 0) {
        colWidths.push('hidden-md');
      } else if (medium && medium !== small) {
        colWidths.push('col-md-' + medium);
      }
      if (large === 0) {
        colWidths.push('hidden-lg');
      } else if (large && large !== medium) {
        colWidths.push('col-lg-' + large);
      }
      return colWidths;
    });
    _defineProperty(_assertThisInitialized(_this), "getColumnOffsets", function () {
      var offsets = [];
      var small = _this.props.offset.small;
      var medium = _this.props.offset.medium;
      var large = _this.props.offset.large;

      // Column offsets
      if (small >= 0) {
        offsets.push('col-sm-offset-' + small);
      }
      if (medium >= 0 && medium !== small) {
        offsets.push('col-md-offset-' + medium);
      }
      if (large >= 0 && large !== medium) {
        offsets.push('col-lg-offset-' + large);
      }
      return offsets;
    });
    return _this;
  }
  _createClass(Column, [{
    key: "render",
    value: function render() {
      var className = [];

      // Column widths
      className = className.concat(this.getColumnWidths());

      // Column offsets
      className = className.concat(this.getColumnOffsets());
      return /*#__PURE__*/React.createElement("div", {
        className: className.join(' '),
        style: {
          boxSizing: 'border-box',
          position: this.props.relative ? 'relative' : 'static'
        }
      }, this.props.children);
    }
  }]);
  return Column;
}(React.Component);
_defineProperty(Column, "propTypes", {
  offset: PropTypes.shape(defaultShape),
  relative: PropTypes.bool,
  span: PropTypes.shape(defaultShape)
});
_defineProperty(Column, "defaultProps", {
  offset: {},
  relative: true,
  span: {
    large: 12
  }
});
module.exports = Column;