"use strict";

var _Theme = require("../Theme");
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var PropTypes = require('prop-types');
var Radium = require('radium');
var React = require('react');
var _require = require('@mxenabled/cssinjs'),
  css = _require.css;
var _require2 = require('../../constants/App'),
  themeShape = _require2.themeShape;
var _require3 = require('../../utils/KeyPress'),
  isEnterOrSpaceKey = _require3.isEnterOrSpaceKey;
var StyleUtils = require('../../utils/Style');
var Tab = /*#__PURE__*/function (_React$Component) {
  _inherits(Tab, _React$Component);
  var _super = _createSuper(Tab);
  function Tab() {
    var _this;
    _classCallCheck(this, Tab);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    _defineProperty(_assertThisInitialized(_this), "_handleSpaceAndEnter", function (e) {
      if (isEnterOrSpaceKey(e)) {
        _this.props.onClick();
      }
    });
    _defineProperty(_assertThisInitialized(_this), "styles", function (theme) {
      return {
        tab: {
          backgroundColor: 'transparent',
          border: 'none',
          boxSizing: 'border-box',
          color: theme.Colors.GRAY_500,
          cursor: 'pointer',
          display: 'inline-block',
          fontSize: theme.FontSizes.MEDIUM,
          fontStyle: theme.Fonts.SEMIBOLD,
          padding: theme.Spacing.MEDIUM,
          whiteSpace: 'nowrap',
          '&:hover': {
            color: theme.Colors.GRAY_700
          },
          '&:focus': {
            backgroundColor: theme.Colors.GRAY_300,
            color: theme.Colors.GRAY_700
          }
        },
        activeTab: _extends({
          cursor: 'default',
          color: theme.Colors.PRIMARY,
          borderBottom: '2px solid ' + theme.Colors.PRIMARY,
          '&:hover': {
            color: theme.Colors.PRIMARY
          }
        }, _this.props.activeTabStyles)
      };
    });
    return _this;
  }
  _createClass(Tab, [{
    key: "render",
    value: function render() {
      var theme = StyleUtils.mergeTheme(this.props.theme);
      var styles = this.styles(theme);
      var style = _extends({}, styles.tab, this.props.styles.tab);
      if (this.props.isActive) style = _extends({}, style, styles.activeTab, this.props.styles.activeTab);
      return /*#__PURE__*/React.createElement("button", {
        "aria-label": "".concat(this.props.children, " tab"),
        className: "mx-tab ".concat(css(style)),
        onClick: this.props.onClick
      }, this.props.children);
    }
  }]);
  return Tab;
}(React.Component);
_defineProperty(Tab, "propTypes", {
  activeTabStyles: PropTypes.object,
  isActive: PropTypes.bool,
  onClick: PropTypes.func,
  styles: PropTypes.object,
  theme: themeShape
});
_defineProperty(Tab, "defaultProps", {
  isActive: false,
  onClick: function onClick() {},
  styles: {}
});
module.exports = (0, _Theme.withTheme)(Radium(Tab));